version: '3'

services:

  fluent-bit:
    image: fluent/fluent-bit
    container_name: lak-fluent-bit
    restart: on-failure
    network_mode: host
    volumes:
      - ./configuration/fluent-bit/fluent-bit.conf:/fluent-bit/etc/fluent-bit.conf

  fluentd:
    build: ./fluentd
    environment:
      - SLACK_WEBHOOK_URL=${SLACK_WEBHOOK_URL}
    volumes:
      - ./configuration/fluentd-influxdb/fluent.conf:/fluentd/etc/fluent.conf
      - ./configuration/fluentd-influxdb/config.d/:/fluentd/etc/config.d/
    network_mode: host
    depends_on:
      - "influxdbv1"
    ports:
      - 24224:24224

  influxdbv1:
    image: influxdb
    container_name: lak-influxdbv1
    restart: always
    environment:
      - TZ=America/Mexico_City
      - INFLUXDB_GRAPHITE_ENABLED=true
      - INFLUXDB_COLLECTD_ENABLED=true
    network_mode: host
    volumes:
      - influxdbv1-volume:/var/lib/influxdb
      - /etc/localtime:/etc/localtime:ro
      - ./configuration/influxdb/collectd/:/usr/share/collectd/
      - ./configuration/influxdb/influx_init.iql:/docker-entrypoint-initdb.d/influx_init.iql

  influxdbv2:
    image: quay.io/influxdb/influxdb:v2.0.3
    container_name: lak-influxdbv2
    restart: always
    environment:
      - TZ=America/Mexico_City
      - INFLUXDB_GRAPHITE_ENABLED=true
      - INFLUXDB_COLLECTD_ENABLED=true
    network_mode: host
    volumes:
      - influxdbv2-volume:/var/lib/influxdb
      - /etc/localtime:/etc/localtime:ro
      - ./configuration/influxdb/collectd/:/usr/share/collectd/
      - ./configuration/influxdb/influx_init.iql:/docker-entrypoint-initdb.d/influx_init.iql

  grafana:
    image: grafana/grafana
    container_name: lak-grafana
    restart: on-failure
    depends_on:
      - "influxdbv1"
    environment:
      - TZ=America/Mexico_City
      - GF_INSTALL_PLUGINS=grafana-clock-panel,briangann-gauge-panel,natel-plotly-panel,grafana-simple-json-datasource,yesoreyeram-boomtable-panel
      - GF_RENDERING_SERVER_URL=http://renderer:8081/render
      - GF_RENDERING_CALLBACK_URL=http://grafana:3000/
      - GF_LOG_FILTERS=rendering:debug
      - GF_PATHS_PROVISIONING=/usr/share/grafana/conf/provisioning/
    network_mode: host
    ports:
      - 3000:3000
    volumes:
      - grafana-volume:/var/lib/grafana
      - ./grafana/provisioning/datasources:/usr/share/grafana/conf/provisioning/datasources:rw
      - ./grafana/provisioning/notifiers:/usr/share/grafana/conf/provisioning/notifiers:rw
      - ./grafana/provisioning/dashboards:/usr/share/grafana/conf/provisioning/dashboards:rw

  renderer:
    image: grafana/grafana-image-renderer:latest
    container_name: lak-image-renderer
    restart: on-failure
    environment:
      ENABLE_METRICS: "true"
    network_mode: host
    ports:
      - 8081:8081

volumes:
  influxdbv1-volume:
  influxdbv2-volume:
  grafana-volume:
